unit Unit1;

interface

uses windows, messages, math, graphics, SysUtils;

type
  trgb = record  //,      ,     
   b,g,r: byte;
  end;

  ARGB = array [0..0] of TRGB;
  PARGB = ^ARGB;

  item1 = record  //  "" 
   x,y:integer;
   tx,ty:integer; //   
   yar:Word; //      
  end;

  item2 = record   //   
   x,y:integer;
   tx,ty:integer; //   
   yar:Word; //      
   ko:byte;
   ko2:byte; // 
  end;

  TBall = record
   x,y:extended; // 
   gx,gy:integer; //       
   prevx,prevy:integer; //      
   dx,dy:extended;//    
   r,g,b:byte;
  end;

 procedure Init;
 function Doedin(x:extended):integer;
 function WindowProc(wnd:HWND; Msg:Integer; Wparam:Wparam; Lparam:Lparam): Longint; stdcall;
 procedure DrawBalls;
 procedure DrawPosition;
 procedure InitPos;
 procedure PrepareTextures;
 procedure CalcProc;

var
  balls:array [1..16] of Tball;
  Bufballs:array [1..16] of Tball;
  trig:boolean=false;
  wc:TWndClassEx;
  MainWnd:THandle;
  Mesg:TMsg;
  DC:HDC;
  ScreenX, ScreenY, len0div2:integer;
  bordLX, bordRX, bordUY, bordDY, shadbordX, shadbordY:extended;
  Thr: LongWord;
  x1,x2,x3:int64;
  pfon,pbuf:array of PARGB;
  c:trgb;
  FrameRate:Word;
  RThr, LThr:LongWord;
  tip1: array of item1;
  tip2: array of item2;
  shad1: array of item1;
  shad2: array of item2;
  len0,len1,len2,lenU3,len0M1,shadlen1,shadlen2:integer;
  diametr, radius, CO:extended;
  soot:array [0..255,0..255] of byte;
  sootyark:array [0..255{ },0..512{ }] of byte;
  Fon, Buffer: TBitmap;
  YarTen:word; // 
  ShadDelta:integer; //    

implementation

function Doedin(x:extended):integer;
 var z:extended; y:integer;
begin
 z:=trunc(frac(x)*10);
 y:=trunc(x);
 if z<0.001 then z:=0;
 if z>4 then result:=y+1 else result:=y;
end;

function DomaxZero(x:extended):integer;
 var z:extended;
begin
 result:=trunc(x);
 z:=frac(x);
 if z>0 then inc(result);
end;

procedure Init;
 var k,x,i,j,z,n,m,f,v:integer;
 ar:array of array of Single;
 k2,k1,k0,c1,c2,t1:extended;
begin
 len2:=0;  // "" , ..    
 shadlen1:=0;
 shadlen2:=0;
 ShadDelta:=doedin(6*co); //   - 8 
 if (diametr*CO)<1 then len0:=1 else len0:=1+2*DomaxZero(abs((diametr*CO)-1)/2);
 lenU3:=len0*3+ShadDelta*3; //        
 len0M1:=len0-1;
 setlength(ar,len0,len0); //     
 k:=30; // ,        ar   
 x:=round(radius*k*CO);
 for i:=0 to x do begin
 z:=round(sqrt(abs(sqr(x)-sqr(i))))-1;
  for j:=0 to z do begin
   n:=round(len0*k/2+i)div k;
   m:=round(len0*k/2+j)div k;
   if (j<>z)or(i<>x) then begin
    ar[n,m]:=ar[n,m]+1;
    ar[len0-n,m]:=ar[len0-n,m]+1;
    ar[n,len0-m]:=ar[n,len0-m]+1;
    ar[len0-n,len0-m]:=ar[len0-n,len0-m]+1;
   end else begin
    ar[n,m]:=ar[n,m]+0.5;
    ar[len0-n,m]:=ar[len0-n,m]+0.5;
    ar[n,len0-m]:=ar[n,len0-m]+0.5;
    ar[len0-n,len0-m]:=ar[len0-n,len0-m]+0.5;
   end;
  end;
 end;

 for i:=0 to len0M1 do
  for j:=0 to len0M1 do begin
    if ar[i,j]>sqr(k) then ar[i,j]:=sqr(k);
    ar[i,j]:=doedin(255*(ar[i,j]/sqr(k)));
    if ar[i,j]=255 then begin
     inc(len1);
     if sqrt(sqr(i-(len0/2)+ShadDelta)+sqr(j-(len0/2)+ShadDelta))>(len0/2) then inc(shadlen1);
    end;
    if (ar[i,j]<255) and (ar[i,j]>0) then begin
     inc(len2);
     if sqrt(sqr(i-(len0/2)+ShadDelta)+sqr(j-(len0/2)+ShadDelta))>(len0/2) then inc(shadlen2);
    end; 
   end;
   
 setlength(tip1,len1);
 setlength(tip2,len2);
 setlength(shad1,shadlen1);
 setlength(shad2,shadlen2);
 k:=0;
 z:=0;
 f:=0;
 v:=0;
 dec(len1); //            
 dec(len2);
 dec(shadlen1);
 dec(shadlen2);
 t1:=len0*0.29; //   
 for i:=0 to len0M1 do
  for j:=0 to len0M1 do begin
   if ar[i,j]=255 then begin

    if sqrt(sqr(i-(len0/2)+ShadDelta)+sqr(j-(len0/2)+ShadDelta))>(len0/2) then begin //
     shad1[f].x:=i+ShadDelta-1; // 
     shad1[f].y:=j+ShadDelta-1;
     inc(f);
    end;

    tip1[k].x:=i;
    tip1[k].y:=j;
    tip1[k].yar:=100+round(412*sqrt(sqr(t1-j)+sqr(t1-i))/(0.9*len0));

    k1:=(i+0.5001)-(len0/2);  //     
    k2:=(j+0.5001)-(len0/2);  //0.5001 -  ,      0
    k0:=sqrt(sqr(k1)+sqr(k2));
    c1:=k1/k0;
    c2:=k2/k0;
    k1:=doedin(len0*pi/2); // 
    k0:=(k1/2)*2*arctan2(k0,sqrt(abs((sqr(len0/2)-sqr(k0)))))/pi;
    tip1[k].ty:=trunc((k1/2)+k0*c1);
    tip1[k].tx:=trunc((k1/2)+k0*c2);

    inc(k);
   end;
   if (ar[i,j]<255) and (ar[i,j]>0) then begin

    if sqrt(sqr(i-(len0/2)+ShadDelta)+sqr(j-(len0/2)+ShadDelta))>(len0/2) then begin //
     shad2[v].x:=i+ShadDelta-1; // 
     shad2[v].y:=j+ShadDelta-1;
     shad2[v].ko:=byte(round((ar[i,j])));
     shad2[v].ko2:=255-shad2[v].ko;
     inc(v);
    end;

    tip2[z].x:=i;
    tip2[z].y:=j;
    tip2[z].yar:=100+round(412*sqrt(sqr(t1-j)+sqr(t1-i))/(0.9*len0));
    tip2[z].ko:=byte(round((ar[i,j])));
    tip2[z].ko2:=255-tip2[z].ko;

    k1:=(i+0.5001)-(len0/2);  //     
    k2:=(j+0.5001)-(len0/2);  //0.5001 -  ,      0
    k0:=sqrt(sqr(k1)+sqr(k2));
    c1:=k1/k0;
    c2:=k2/k0;
    k1:=doedin(len0*pi/2); // 
    k0:=(k1/2)*2*arctan2(k0,sqrt(abs((sqr(len0/2)-sqr(k0)))))/pi;
    tip2[z].ty:=trunc((k1/2)+k0*c1);
    tip2[z].tx:=trunc((k1/2)+k0*c2);

    inc(z);
   end;
  end;
 ar:=nil;
 for i:=0 to 255 do for j:=0 to 255 do soot[i,j]:=trunc(j*i/255);

 for i:=0 to 255 do begin
  sootyark[i,256]:=i;    //  
  for j:=0 to 255 do sootyark[i,j]:=doedin(255-(((255-i)/256)*j));//  
  for j:=257 to 512 do sootyark[i,j]:=doedin((i/256)*(255-j+257));//  
 end;

 len0div2:=len0 div 2;
end;

procedure DrawBalls;
 var i,j,px,py,x,y,xh,yh,dx,dy:integer;
 dist:extended;
begin
 for j:=1 to 16 do begin
  x:=balls[j].prevx*3;
  for i:=0 to len0M1+ShadDelta do begin  //     
   y:=balls[j].prevy+i;
   CopyMemory(pointer(integer(pbuf[y])+x),pointer(integer(pfon[y])+x),lenU3);
  end;
 end;

 for j:=1 to 16 do begin
  balls[j].gy:=trunc(balls[j].y*CO)-len0div2; //       
  balls[j].gx:=trunc(balls[j].x*CO)-len0div2;
   for i:=0 to shadlen1 do begin    //  
    x:=balls[j].gx+shad1[i].x;
    y:=balls[j].gy+shad1[i].y;
    c.b:=sootyark[pfon[y,x].b,YarTen];
    c.r:=sootyark[pfon[y,x].r,YarTen];
    c.g:=sootyark[pfon[y,x].g,YarTen];
    pbuf[y,x]:=c;
   end;
   for i:=0 to shadlen2 do begin
    x:=balls[j].gx+shad2[i].x;
    y:=balls[j].gy+shad2[i].y;
    c.b:=soot[shad2[i].ko2,pfon[y,x].b]+soot[shad2[i].ko,sootyark[pfon[y,x].b,YarTen]];
    c.g:=soot[shad2[i].ko2,pfon[y,x].g]+soot[shad2[i].ko,sootyark[pfon[y,x].g,YarTen]];
    c.r:=soot[shad2[i].ko2,pfon[y,x].r]+soot[shad2[i].ko,sootyark[pfon[y,x].r,YarTen]];
    pbuf[y,x]:=c;
   end;    
 end;  

 for j:=1 to 16 do begin //           
  for i:=0 to len1 do begin
   c.b:=sootyark[balls[j].b,tip1[i].yar];
   c.r:=sootyark[balls[j].r,tip1[i].yar];
   c.g:=sootyark[balls[j].g,tip1[i].yar];
   pbuf[tip1[i].y+balls[j].gy,tip1[i].x+balls[j].gx]:=c;
  end;
  for i:=0 to len2 do begin
   x:=tip2[i].x+balls[j].gx;
   y:=tip2[i].y+balls[j].gy;
   c.b:=soot[tip2[i].ko2,pbuf[y,x].b]+soot[tip2[i].ko,sootyark[balls[j].b,tip2[i].yar]];
   c.g:=soot[tip2[i].ko2,pbuf[y,x].g]+soot[tip2[i].ko,sootyark[balls[j].g,tip2[i].yar]];
   c.r:=soot[tip2[i].ko2,pbuf[y,x].r]+soot[tip2[i].ko,sootyark[balls[j].r,tip2[i].yar]];
   pbuf[y,x]:=c;
  end;
 end;

 for j:=1 to 16 do begin //           
  px:=balls[j].gx-balls[j].prevx;
  py:=balls[j].gy-balls[j].prevy;
  if px>0 then xh:=balls[j].prevx else xh:=balls[j].gx;
  if py>0 then yh:=balls[j].prevy else yh:=balls[j].gy;
  bitblt(DC,xh,yh,ShadDelta+len0+abs(px),ShadDelta+len0+abs(py),buffer.Canvas.Handle,xh,yh,srccopy);  
  balls[j].prevy:=balls[j].gy;
  balls[j].prevx:=balls[j].gx;
 end;
end;

procedure DrawPosition;
begin
 DrawBalls;
 BitBlt(dc,0,0,buffer.Width,buffer.Height,buffer.Canvas.Handle,0,0,srccopy); // ,   
end;
                                     
procedure PrepareTextures;
 var i:integer;
begin
 fon:=TBitMap.Create;
 fon.PixelFormat:=pf24bit;
 fon.Width:=ScreenX+ShadDelta*2;
 fon.Height:=ScreenY+ShadDelta*2;
 fon.Canvas.Brush.Color:=3774210;
 fon.Canvas.FillRect(fon.Canvas.ClipRect);
 setlength(pfon,fon.Height);
 for i:=0 to fon.Height-1 do pfon[i]:=fon.scanline[i];

 buffer:=TBitMap.Create;   //  
 buffer.PixelFormat:=pf24bit;
 buffer.Width:=fon.Width;
 buffer.Height:=fon.Height;
 setlength(pbuf,buffer.Height);
 for i:=0 to buffer.Height-1 do pbuf[i]:=buffer.scanline[i];

  balls[1].r:=0;
  balls[1].g:=0;
  balls[1].b:=0;
 for i:=2 to 16 do begin
  balls[i].r:=255;
  balls[i].g:=0;
  balls[i].b:=0;
 end;
{ for i:=9 to 16 do begin
  balls[i].r:=255;
  balls[i].g:=255;
  balls[i].b:=0;
 end;   }

end;

procedure InitPos;
 var j:integer;
begin
 BitBlt(buffer.Canvas.Handle,0,0,buffer.Width,buffer.Height,fon.Canvas.Handle,0,0,srccopy);
 randomize;
 for j:=1 to 4 do begin
  balls[j].x:=180+(diametr)*2*j;  // 
  balls[j].y:=150;
  balls[j].dx:=0;//(0.5-random)/3;  // 
  balls[j].dy:=0;//(0.5-random)/3;

  balls[j+4].x:=180+(diametr)*2*j;  // 
  balls[j+4].y:=200;
  balls[j+4].dx:=0;//(0.5-random)/3;  // 
  balls[j+4].dy:=0;//(0.5-random)/3;

  balls[j+8].x:=180+(diametr)*2*j;  // 
  balls[j+8].y:=250;
  balls[j+8].dx:=0;//(0.5-random)/3;  // 
  balls[j+8].dy:=0;//(0.5-random)/3;

  balls[j+12].x:=180+(diametr)*2*j;  //  
  balls[j+12].y:=300;
  balls[j+12].dx:=0;//(0.5-random)/3;  // 
  balls[j+12].dy:=0;//(0.5-random)/3;
 end;
end; 

procedure CalcProc;
 var i,j,z1:integer;
 a,b,d1,d2,p1,p2,p3,{d11,d12,d21,d3,d4,d41,d42,d31,d32,d22,}dist,sum:extended;
begin
 z1:=0;
 sum:=0;
 while trig do begin
  for j:=2 to 16 do begin
   a:=(balls[1].x-balls[j].x);
   b:=(balls[1].y-balls[j].y);
   dist:=sqrt(sqr(a)+sqr(b));
   p1:=1e-6*(dist-1*diametr); //     
   d1:=p1*a/dist;
   d2:=p1*b/dist;
   balls[j].dx:=balls[j].dx+d1;
   balls[j].dy:=balls[j].dy+d2;
  end;

  for i:=2 to 15 do   //   
  for j:=i+1 to 16 do begin
   dist:=sqrt(sqr(balls[i].x-balls[j].x)+sqr(balls[i].y-balls[j].y));
   if dist<diametr then begin // 
    a:=balls[i].x-balls[j].x;
    b:=balls[i].y-balls[j].y;
    p1:=a*b/sqr(dist);
    p2:=sqr(a/dist);
    p3:=sqr(b/dist);
    d1:=balls[i].dy*p1+balls[i].dx*p2-balls[j].dy*p1-balls[j].dx*p2;
    d2:=balls[i].dx*p1+balls[i].dy*p3-balls[j].dx*p1-balls[j].dy*p3;
    balls[i].dx:=balls[i].dx-d1;
    balls[i].dy:=balls[i].dy-d2;
    balls[j].dx:=balls[j].dx+d1;
    balls[j].dy:=balls[j].dy+d2;
    p3:=(diametr-dist)/2;   // 
    p1:=p3*(a/dist);
    p2:=p3*(b/dist);
    balls[i].x:=balls[i].x+p1;;
    balls[i].y:=balls[i].y+p2;
    balls[j].x:=balls[j].x-p1;
    balls[j].y:=balls[j].y-p2;    
   end;
  end;

  inc(z1);
  if z1>FrameRate then begin //  z1-  
   DrawBalls;
   z1:=0;
  end;

  for i:=1 to 16 do begin
    if balls[i].y<bordUY then begin  //   
     balls[i].y:=bordUY;
     balls[i].dy:=-balls[i].dy;
    end;
    if balls[i].y>bordDY then begin  //   
     balls[i].y:=bordDY;
     balls[i].dy:=-balls[i].dy;
    end;
    if balls[i].x<bordLX then begin   //   
     balls[i].x:=bordLX;
     balls[i].dx:=-balls[i].dx;
    end;
    if balls[i].x>bordRX then begin   //   
     balls[i].x:=bordRX;
     balls[i].dx:=-balls[i].dx;
    end;

   sum:=sum+sqrt(sqr(balls[i].dx)+sqr(balls[i].dy));   
   balls[i].x:=balls[i].x+balls[i].dx;  // 
   balls[i].y:=balls[i].y+balls[i].dy;
  end;
  textout(dc,10,10,pchar(floattostr(sum)),5);
  sum:=0;
 end;
end;

function WindowProc(wnd:HWND; Msg:Integer; Wparam:Wparam; Lparam:Lparam): Longint; stdcall;
begin
 Result:=0;
 case msg of
  WM_LBUTTONDOWN: Postmessage(MainWnd,WM_DESTROY,0,0);
  WM_DESTROY:begin
    trig:=false;
    sleep(100);
    buffer.Free;
    fon.Free;
    windows.unregisterclass('Impact',hinstance);
    postquitmessage(0);
   end;
 else Result:=DefWindowProc(wnd,msg,wparam,lparam); end;
end;

end.
